// $Id: prio.c,v 1.3 2005/01/04 21:12:43 jo Exp $
// Author: Johannes Totz <johannes@jo-t.de>

#include <windows.h>

int main(int argc, char* argv[])
{
	return WinMain(NULL, NULL, "", SW_SHOWNORMAL);
}

int APIENTRY WinMain(HINSTANCE inst, HINSTANCE prev, char* cmdline, int show)
{
	ATOM			key_atom	= 0;
	unsigned int	key_mods	= MOD_WIN | MOD_SHIFT;	// MOD_ALT MOD_CONTROL
	unsigned int	key_vk		= 'A';

	if ((key_atom = GlobalAddAtom("prio-hotkey-atom")) != 0)
	{		
		if (RegisterHotKey(NULL, key_atom, key_mods, key_vk) != 0)
		{
			MSG		msg;
			int		quit = 0;
			while (quit == 0)
			{
				if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE) != 0)
				{
					switch (msg.message)
					{
						case WM_HOTKEY:
							if ((LOWORD(msg.lParam) == key_mods) && (HIWORD(msg.lParam) == key_vk))
							{
								HWND	wnd = NULL;
								if ((wnd = GetForegroundWindow()) != NULL)
								{
									DWORD	tid	= 0;
									DWORD	pid = 0;
									
									tid = GetWindowThreadProcessId(wnd, &pid);
									
									HANDLE	process = NULL;
									if ((process = OpenProcess(PROCESS_SET_INFORMATION, FALSE, pid)) != NULL)
									{
										if (SetPriorityClass(process, BELOW_NORMAL_PRIORITY_CLASS) != 0)
											;//quit = 1;
										CloseHandle(process);
									}
								}
							}
							break;

						case WM_QUIT:
							quit = 1;
							break;
							
						default:
							TranslateMessage(&msg);
							DispatchMessage(&msg);
					}
				}
				else
					WaitMessage();
			}
			UnregisterHotKey(NULL, key_atom);
		}
		GlobalDeleteAtom(key_atom);
	}
	
	return 0;
}
